//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UBill DescribeOrderDetailInfo

package ubill

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeOrderDetailInfoRequest is request schema for DescribeOrderDetailInfo action
type DescribeOrderDetailInfoRequest struct {
	request.CommonBase

	// 	开始时间
	BeginTime *int `required:"true"`

	// 结束时间(时间跨度不超过3个月)
	EndTime *int `required:"true"`

	// 业务组
	Tags []string `required:"false"`

	// 地区(默认全部)
	AzGroups []string `required:"false"`

	// 可用区，原：数据中心(默认全部)
	Regions []string `required:"false"`

	// 产品类型(默认全部)[全部产品类型]
	ResourceTypes []string `required:"false"`

	// 订单类型(默认全部)[全部订单类型]
	OrderTypes []string `required:"false"`

	// 付费类别(默认全部OrderType)[全部计费方式]
	ChargeTypes []string `required:"false"`

	// 订单状态(默认全部可选参数)[OS_FINISHED;OS_UNDO]
	OrderStates []string `required:"false"`

	// 是否开过发票(默认全部可选参数)[INVO_ON:未开过;INVO_OFF:开过]
	Invoiceds []string `required:"false"`

	// 返回数据长度(默认为25)[1~100]
	Limit *int `required:"false"`

	// 数据偏移量(默认为0)
	Offset *int `required:"false"`

	// 资源ID(短ID)
	ResourceIds []string `required:"false"`

	// 交易订单号(该字段存在时,可以不传BeginTime和EndTime)
	TradeNos []string `required:"false"`

	// ‘true’表示查询全部(默认全部)其他选项按项目组查询
	QueryAll *string `required:"false"`
}

// DescribeOrderDetailInfoResponse is response schema for DescribeOrderDetailInfo action
type DescribeOrderDetailInfoResponse struct {
	response.CommonBase

	// JSON格式的订单信息
	OrderInfos []interface{}
}

// NewDescribeOrderDetailInfoRequest will create request of DescribeOrderDetailInfo action.
func (c *UBillClient) NewDescribeOrderDetailInfoRequest() *DescribeOrderDetailInfoRequest {
	req := &DescribeOrderDetailInfoRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeOrderDetailInfo - 获取订单信息
func (c *UBillClient) DescribeOrderDetailInfo(req *DescribeOrderDetailInfoRequest) (*DescribeOrderDetailInfoResponse, error) {
	var err error
	var res DescribeOrderDetailInfoResponse

	err = c.Client.InvokeAction("DescribeOrderDetailInfo", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
