//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UHost GetRestResource

package uhost

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// GetRestResourceRequest is request schema for GetRestResource action
type GetRestResourceRequest struct {
	request.CommonBase

	// 可用区。参见 [可用区列表](../summary/regionlist.html)
	Zone *string `required:"false"`

	// Normal: 普通资源；SSD: ssd资源；BigData：大数据资源； GPU: gpu资源； 默认为GPU（目前只支持GPU）
	ResourceType *string `required:"false"`

	// UHost实例ID 参见 [DescribeUHostInstance](describe_uhost_instance.html)
	UHostId *string `required:"false"`

	// 目标虚拟CPU核数，单位：个，范围：[2,32]。默认值为当前实例的CPU核数
	CPU *int `required:"false"`

	// 内存大小，单位：MB，范围[2048,65536]，步长：2048，默认值为当前实例的内存大小
	Memory *int `required:"false"`

	// 数据盘大小，单位：GB，范围[10,1000]； SSD机型，单位：GB，范围[100,500]；步长：10，默认值为当前实例的数据盘大小，数据盘不支持缩容，因此不允许输入比当前实例数据盘大小的值
	DiskSpace *int `required:"false"`

	// 系统盘大小，单位：GB，范围[20,100]，步长：10，系统盘不支持缩容，因此不允许输入比当前实例系统盘小的值
	BootDiskSpace *int `required:"false"`
}

// GetRestResourceResponse is response schema for GetRestResource action
type GetRestResourceResponse struct {
	response.CommonBase

	// 返回资源数组
	ResourceInfos []ResourceInfoSet

	// 是否能成功升级
	UpgradeStatus bool
}

// NewGetRestResourceRequest will create request of GetRestResource action.
func (c *UHostClient) NewGetRestResourceRequest() *GetRestResourceRequest {
	req := &GetRestResourceRequest{}
	c.Client.SetupRequest(req)
	return req
}

// GetRestResource - 获取某种类型是否有剩余资源；主机升级配置前获取资源是否充足
func (c *UHostClient) GetRestResource(req *GetRestResourceRequest) (*GetRestResourceResponse, error) {
	var err error
	var res GetRestResourceResponse

	err = c.Client.InvokeAction("GetRestResource", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
