//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UFS DescribeUFSVolumePrice

package ufs

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeUFSVolumePriceRequest is request schema for DescribeUFSVolumePrice action
type DescribeUFSVolumePriceRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// 文件系统大小，大小1024G ~ 25600G (1T ~ 25T)，必须为1024的整数倍。
	Size *int `required:"true"`

	// 文件存储类型，枚举值，Basic表示容量型产品，Advanced表示性能型产品
	StorageType *string `required:"true"`

	// 购买UFS的时长， 默认为1
	Quantity *int `required:"false"`

	// Year， Month， Dynamic，Trial，默认: Dynamic
	ChargeType *string `required:"false"`
}

// DescribeUFSVolumePriceResponse is response schema for DescribeUFSVolumePrice action
type DescribeUFSVolumePriceResponse struct {
	response.CommonBase

	// ufs 价格信息
	DataSet []UFSPriceDataSet
}

// NewDescribeUFSVolumePriceRequest will create request of DescribeUFSVolumePrice action.
func (c *UFSClient) NewDescribeUFSVolumePriceRequest() *DescribeUFSVolumePriceRequest {
	req := &DescribeUFSVolumePriceRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeUFSVolumePrice - 获取文件系统价格
func (c *UFSClient) DescribeUFSVolumePrice(req *DescribeUFSVolumePriceRequest) (*DescribeUFSVolumePriceResponse, error) {
	var err error
	var res DescribeUFSVolumePriceResponse

	err = c.Client.InvokeAction("DescribeUFSVolumePrice", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
