//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UMem DescribeUMem

package umem

import (
	"github.com/ucloud/ucloud-sdk-go/private/utils"
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeUMemRequest is request schema for DescribeUMem action
type DescribeUMemRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// [公共参数] 可用区。参见 [可用区列表](../summary/regionlist.html)
	// Zone *string `required:"false"`

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// 协议类型: memcache, redis
	Protocol *string `required:"false"`

	// 分页显示的起始偏移, 默认值为0
	Offset *int `required:"false"`

	// 分页显示的条目数, 默认值为20
	Limit *int `required:"false"`

	// 资源ID
	ResourceId *string `required:"false"`

	//
	ResourceType *string `required:"false"`
}

// DescribeUMemResponse is response schema for DescribeUMem action
type DescribeUMemResponse struct {
	response.CommonBase

	// 根据过滤条件得到的总数
	TotalCount int

	// UMem实例列表, 详细参见UMemDataSet
	DataSet []UMemDataSet
}

// NewDescribeUMemRequest will create request of DescribeUMem action.
func (c *UMemClient) NewDescribeUMemRequest() *DescribeUMemRequest {
	req := &DescribeUMemRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeUMem - 获取UMem列表
func (c *UMemClient) DescribeUMem(req *DescribeUMemRequest) (*DescribeUMemResponse, error) {
	var err error
	var res DescribeUMemResponse

	err = c.Client.InvokeActionWithPatcher("DescribeUMem", req, &res, utils.PortPatcher)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
