// Code is generated by ucloud-model, DO NOT EDIT IT.

package ipsecvpn

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// CreateVPNTunnelRequest is request schema for CreateVPNTunnel action
type CreateVPNTunnelRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// IKE协商过程中使用的认证算法，"md5", "sha1", "sha2-256"。默认值为“sha1”
	IKEAuthenticationAlgorithm *string `required:"false"`

	// IKE协商过程中使用的DH组，枚举值，"1", "2", "5", "14", "15", "16"。默认为“15”
	IKEDhGroup *string `required:"false"`

	// IKE协商过程中使用的加密算法，枚举值，"aes128", "aes192", "aes256", "aes512", "3des"。默认值为“aes128”
	IKEEncryptionAlgorithm *string `required:"false"`

	// IKE协商过程中使用的模式，枚举值，主模式，“main”；野蛮模式，“aggressive”。IKEV1默认为主模式“main”，IKEV2时不使用该参数。
	IKEExchangeMode *string `required:"false"`

	// 本端标识。枚举值，自动识别，“auto”；IP地址或域名。默认为自动识别“auto”。IKEV2必填该参数
	IKELocalId *string `required:"false"`

	// 预共享密钥
	IKEPreSharedKey *string `required:"true"`

	// 客户端标识。枚举值，自动识别，“auto”；IP地址或域名。默认为“自动识别“auto”。IKEV2必填该参数
	IKERemoteId *string `required:"false"`

	// IKE中SA的生存时间，可填写范围为600-604800。默认为86400。
	IKESALifetime *string `required:"false"`

	// ike版本，枚举值： "IKE V1"，"IKE V2"，默认v1
	IKEVersion *string `required:"true"`

	// IPSec隧道中使用的认证算法，枚举值，"md5", "sha1"。默认值为“sha1”
	IPSecAuthenticationAlgorithm *string `required:"false"`

	// IPSec隧道中使用的加密算法，枚举值，"aes128", "aes192", "aes256", "aes512", "3des"。默认值为“aes128”
	IPSecEncryptionAlgorithm *string `required:"false"`

	// 指定VPN连接的本地子网的资源ID，最多可填写10个。
	IPSecLocalSubnetIds []string `required:"true"`

	// IPSec的PFS是否开启，枚举值，，不开启，"disable"；数字表示DH组, "1", "2", "5", "14", "15", "16"。默认为“disable”。
	IPSecPFSDhGroup *string `required:"false"`

	// 使用的安全协议，枚举值，“esp”，“ah”。默认为“esp”
	IPSecProtocol *string `required:"false"`

	// 指定VPN连接的客户网段，最多可填写20个。
	IPSecRemoteSubnets []string `required:"true"`

	// IPSec中SA的生存时间，可填写范围为1200 - 604800。默认为3600
	IPSecSALifetime *string `required:"false"`

	// IPSec中SA的生存时间（以字节计）。可选为8000 – 20000000。默认使用SA生存时间，
	IPSecSALifetimeBytes *string `required:"false"`

	// 备注，默认为空
	Remark *string `required:"false"`

	// 客户VPN网关的资源ID
	RemoteVPNGatewayId *string `required:"true"`

	// 业务组，默认为“Default”
	Tag *string `required:"false"`

	// vpcId
	VPCId *string `required:"true"`

	// VPN网关的资源ID
	VPNGatewayId *string `required:"true"`

	// VPN隧道名称
	VPNTunnelName *string `required:"true"`
}

// CreateVPNTunnelResponse is response schema for CreateVPNTunnel action
type CreateVPNTunnelResponse struct {
	response.CommonBase

	// VPN隧道的资源ID
	VPNTunnelId string
}

// NewCreateVPNTunnelRequest will create request of CreateVPNTunnel action.
func (c *IPSecVPNClient) NewCreateVPNTunnelRequest() *CreateVPNTunnelRequest {
	req := &CreateVPNTunnelRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

// CreateVPNTunnel - 创建VPN隧道
func (c *IPSecVPNClient) CreateVPNTunnel(req *CreateVPNTunnelRequest) (*CreateVPNTunnelResponse, error) {
	var err error
	var res CreateVPNTunnelResponse

	reqCopier := *req

	err = c.Client.InvokeAction("CreateVPNTunnel", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
