// Code is generated by ucloud-model, DO NOT EDIT IT.

package ipsecvpn

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeRemoteVPNGatewayRequest is request schema for DescribeRemoteVPNGateway action
type DescribeRemoteVPNGatewayRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 数据分页值, 默认为20
	Limit *int `required:"false"`

	// 数据偏移量, 默认为0
	Offset *int `required:"false"`

	// 客户VPN网关的资源ID，例如RemoteVPNGatewayIds.0代表希望获取客户VPN网关1的信息，RemoteVPNGatewayIds.1代表客户VPN网关2，如果为空，则返回当前Region中所有客户VPN网关实例的信息
	RemoteVPNGatewayIds []string `required:"false"`

	// 业务组名称，若指定则返回业务组下所有客户VPN网关信息
	Tag *string `required:"false"`
}

// DescribeRemoteVPNGatewayResponse is response schema for DescribeRemoteVPNGateway action
type DescribeRemoteVPNGatewayResponse struct {
	response.CommonBase

	// 客户VPN网关列表, 每项参数详见 RemoteVPNGatewayDataSet
	DataSet []RemoteVPNGatewayDataSet

	// 符合条件的客户VPN网关总数
	TotalCount int
}

// NewDescribeRemoteVPNGatewayRequest will create request of DescribeRemoteVPNGateway action.
func (c *IPSecVPNClient) NewDescribeRemoteVPNGatewayRequest() *DescribeRemoteVPNGatewayRequest {
	req := &DescribeRemoteVPNGatewayRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeRemoteVPNGateway - 获取客户VPN网关信息
func (c *IPSecVPNClient) DescribeRemoteVPNGateway(req *DescribeRemoteVPNGatewayRequest) (*DescribeRemoteVPNGatewayResponse, error) {
	var err error
	var res DescribeRemoteVPNGatewayResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribeRemoteVPNGateway", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
