// Code is generated by ucloud-model, DO NOT EDIT IT.

package ipsecvpn

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeVPNGatewayRequest is request schema for DescribeVPNGateway action
type DescribeVPNGatewayRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 数据分页值。默认为20
	Limit *int `required:"false"`

	// 数据偏移量。默认为0
	Offset *int `required:"false"`

	// 业务组名称，若指定则返回指定的业务组下的所有VPN网关的信息。
	Tag *string `required:"false"`

	// VPC的资源ID，返回指定的VPC下的所有VPN网关的信息。默认返回当前Region中所有VPN网关实例的信息
	VPCId *string `required:"false"`

	// VPN网关的资源ID，例如VPNGatewayIds.0代表希望获取VPN网关1的信息，VPNGatewayIds.1代表VPN网关2，如果为空，则返回当前Region中所有VPN网关的信息
	VPNGatewayIds []string `required:"false"`
}

// DescribeVPNGatewayResponse is response schema for DescribeVPNGateway action
type DescribeVPNGatewayResponse struct {
	response.CommonBase

	// 获取的VPN网关信息列表，每项参数详见 VPNGatewayDataSet
	DataSet []VPNGatewayDataSet

	// 满足条件的VPN网关总数
	TotalCount int
}

// NewDescribeVPNGatewayRequest will create request of DescribeVPNGateway action.
func (c *IPSecVPNClient) NewDescribeVPNGatewayRequest() *DescribeVPNGatewayRequest {
	req := &DescribeVPNGatewayRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeVPNGateway - 获取VPN网关信息
func (c *IPSecVPNClient) DescribeVPNGateway(req *DescribeVPNGatewayRequest) (*DescribeVPNGatewayResponse, error) {
	var err error
	var res DescribeVPNGatewayResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribeVPNGateway", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
