// Code is generated by ucloud-model, DO NOT EDIT IT.

package ipsecvpn

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeVPNTunnelRequest is request schema for DescribeVPNTunnel action
type DescribeVPNTunnelRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 数据分页值, 默认为20
	Limit *int `required:"false"`

	// 数据偏移量, 默认为0
	Offset *int `required:"false"`

	// 业务组名称，若指定则返回指定的业务组下的所有VPN网关的信息
	Tag *string `required:"false"`

	// VPN隧道的资源ID，例如VPNTunnelIds.0代表希望获取信息的VPN隧道1，VPNTunneIds.1代表VPN隧道2，如果为空，则返回当前Region中所有的VPN隧道实例
	VPNTunnelIds []string `required:"false"`
}

// DescribeVPNTunnelResponse is response schema for DescribeVPNTunnel action
type DescribeVPNTunnelResponse struct {
	response.CommonBase

	// 获取的VPN隧道信息列表，每项参数详见 VPNTunnelDataSet
	DataSet []VPNTunnelDataSet

	// VPN隧道总数
	TotalCount int
}

// NewDescribeVPNTunnelRequest will create request of DescribeVPNTunnel action.
func (c *IPSecVPNClient) NewDescribeVPNTunnelRequest() *DescribeVPNTunnelRequest {
	req := &DescribeVPNTunnelRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeVPNTunnel - 获取VPN隧道信息
func (c *IPSecVPNClient) DescribeVPNTunnel(req *DescribeVPNTunnelRequest) (*DescribeVPNTunnelResponse, error) {
	var err error
	var res DescribeVPNTunnelResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribeVPNTunnel", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
