// Code is generated by ucloud-model, DO NOT EDIT IT.

package ubill

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// GetBillDataFileUrlRequest is request schema for GetBillDataFileUrl action
type GetBillDataFileUrlRequest struct {
	request.CommonBase

	// 账期（时间戳格式）
	BillPeriod *int `required:"true"`

	// 账单类型，传 0 时获取账单总览报表，传 1 获取账单明细报表
	BillType *int `required:"true"`

	// 获取账单总览报表时，账单的支付状态，传 0 时获取待支付账单，传 1 时获取已支付账单。获取账单明细报表时该参数无效
	PaidType *int `required:"false"`
}

// GetBillDataFileUrlResponse is response schema for GetBillDataFileUrl action
type GetBillDataFileUrlResponse struct {
	response.CommonBase

	// 交易账单数据下载URL
	FileUrl string

	// 生成的 URL是否有效，即有对应数据文件
	IsValid string
}

// NewGetBillDataFileUrlRequest will create request of GetBillDataFileUrl action.
func (c *UBillClient) NewGetBillDataFileUrlRequest() *GetBillDataFileUrlRequest {
	req := &GetBillDataFileUrlRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// GetBillDataFileUrl - 生成账单数据文件下载的 url
func (c *UBillClient) GetBillDataFileUrl(req *GetBillDataFileUrlRequest) (*GetBillDataFileUrlResponse, error) {
	var err error
	var res GetBillDataFileUrlResponse

	reqCopier := *req

	err = c.Client.InvokeAction("GetBillDataFileUrl", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
