//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UDB CreateUDBInstance

package udb

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// CreateUDBInstanceRequest is request schema for CreateUDBInstance action
type CreateUDBInstanceRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// [公共参数] 可用区。参见 [可用区列表](../summary/regionlist.html)
	// Zone *string `required:"true"`

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// 实例名称，至少6位
	Name *string `required:"true"`

	// 管理员密码
	AdminPassword *string `required:"true"`

	// DB类型id，mysql/mongodb/postgesql按版本细分 1：mysql-5.1，2：mysql-5.5，3：percona-5.5，4：mysql-5.6，5：percona-5.6，6：mysql-5.7，7：percona-5.7，8：mariadb-10.0，9：mongodb-2.4，10：mongodb-2.6，11：mongodb-3.0，12：mongodb-3.2,13：postgresql-9.4，14：postgresql-9.6，14：postgresql-10.4
	DBTypeId *string `required:"true"`

	// 端口号，mysql默认3306，mongodb默认27017，postgresql默认5432
	Port *int `required:"true"`

	// 磁盘空间(GB), 暂时支持20G - 3000G
	DiskSpace *int `required:"true"`

	// DB实例使用的配置参数组id
	ParamGroupId *int `required:"true"`

	// 内存限制(MB)，目前支持以下几档 1000M/2000M/4000M/ 6000M/8000M/12000M/16000M/ 24000M/32000M/48000M/ 64000M/96000M
	MemoryLimit *int `required:"true"`

	// 当DB类型(DBTypeId)为mongodb时，需要指定mongo的角色，可选值为configsrv (配置节点)，shardsrv (数据节点)
	ClusterRole *string `required:"false"`

	// Year， Month， Dynamic，Trial，默认: Month
	ChargeType *string `required:"false"`

	// 购买时长，默认值1
	Quantity *int `required:"false"`

	// 管理员帐户名，默认root
	AdminUser *string `required:"false"`

	// 备份策略，每周备份数量，默认7次
	BackupCount *int `required:"false"`

	// 备份策略，备份开始时间，单位小时计，默认1点
	BackupTime *int `required:"false"`

	// 备份策略，备份时间间隔，单位小时计，默认24小时
	BackupDuration *int `required:"false"`

	// 备份id，如果指定，则表明从备份恢复实例
	BackupId *int `required:"false"`

	// 是否使用SSD，默认为false
	UseSSD *bool `required:"false"`

	// SSD类型，可选值为"SATA"、"PCI-E"，如果UseSSD为true ，则必选
	SSDType *string `required:"false"`

	// UDB实例模式类型, 可选值如下: "Normal": 普通版UDB实例 "HA": 高可用版UDB实例 默认是"Normal"
	InstanceMode *string `required:"false"`

	// 专区ID信息（如果这个参数存在这说明是在专区中创建DB）
	UDBCId *string `required:"false"`

	// cpu核数
	CPU *int `required:"false"`

	// UDB数据库机型
	InstanceType *string `required:"false"`

	// 跨可用区高可用备库所在可用区，参见 [可用区列表](../summary/regionlist.html)
	BackupZone *string `required:"false"`

	// 子网ID
	SubnetId *string `required:"false"`

	// VPC的ID
	VPCId *string `required:"false"`

	// 是否开启异步高可用，默认不填，可置为true
	DisableSemisync *bool `required:"false"`

	// 使用的代金券id
	CouponId *string `required:"false"`

	// 业务组
	Tag *string `required:"false"`
}

// CreateUDBInstanceResponse is response schema for CreateUDBInstance action
type CreateUDBInstanceResponse struct {
	response.CommonBase

	// db实例id
	DBId string
}

// NewCreateUDBInstanceRequest will create request of CreateUDBInstance action.
func (c *UDBClient) NewCreateUDBInstanceRequest() *CreateUDBInstanceRequest {
	req := &CreateUDBInstanceRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

// CreateUDBInstance - 创建UDB实例（包括创建mysql master节点、mongodb primary/configsvr节点和从备份恢复实例）
func (c *UDBClient) CreateUDBInstance(req *CreateUDBInstanceRequest) (*CreateUDBInstanceResponse, error) {
	var err error
	var res CreateUDBInstanceResponse

	err = c.Client.InvokeAction("CreateUDBInstance", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
