//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UDB CreateUDBReplicationInstance

package udb

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// CreateUDBReplicationInstanceRequest is request schema for CreateUDBReplicationInstance action
type CreateUDBReplicationInstanceRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// [公共参数] 可用区。参见 [可用区列表](../summary/regionlist.html)
	// Zone *string `required:"false"`

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// primary节点的DBId,该值可以通过DescribeUDBInstance获取
	SrcId *string `required:"true"`

	// 实例名称，至少6位
	Name *string `required:"true"`

	// 端口号，默认27017，取值范围3306至65535。
	Port *int `required:"false"`

	// 是否是仲裁节点，默认false，仲裁节点按最小机型创建
	IsArbiter *bool `required:"false"`

	// 是否使用SSD，默认不使用
	UseSSD *bool `required:"false"`

	// 使用的代金券id
	CouponId *string `required:"false"`
}

// CreateUDBReplicationInstanceResponse is response schema for CreateUDBReplicationInstance action
type CreateUDBReplicationInstanceResponse struct {
	response.CommonBase

	// 创建从节点的DBId
	DBId string
}

// NewCreateUDBReplicationInstanceRequest will create request of CreateUDBReplicationInstance action.
func (c *UDBClient) NewCreateUDBReplicationInstanceRequest() *CreateUDBReplicationInstanceRequest {
	req := &CreateUDBReplicationInstanceRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

// CreateUDBReplicationInstance - 创建MongoDB的副本节点（包括仲裁）
func (c *UDBClient) CreateUDBReplicationInstance(req *CreateUDBReplicationInstanceRequest) (*CreateUDBReplicationInstanceResponse, error) {
	var err error
	var res CreateUDBReplicationInstanceResponse

	err = c.Client.InvokeAction("CreateUDBReplicationInstance", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
