//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UDB DescribeUDBInstancePrice

package udb

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeUDBInstancePriceRequest is request schema for DescribeUDBInstancePrice action
type DescribeUDBInstancePriceRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// [公共参数] 可用区。参见 [可用区列表](../summary/regionlist.html)
	// Zone *string `required:"true"`

	// 内存限制(MB)，单位为MB.目前支持：1000-96000
	MemoryLimit *int `required:"true"`

	// 磁盘空间(GB),暂时支持20(GB) - 3000(GB), 输入不带单位
	DiskSpace *int `required:"true"`

	// 购买DB实例数量,最大数量为10台, 默认为1台
	Count *int `required:"false"`

	// Year，按年付费； Month，按月付费 Dynamic，按需付费（需开启权限) Trial，试用（需开启权限）默认为月付
	ChargeType *string `required:"false"`

	// DB购买多少个"计费时间单位"，默认值为1。比如：买2个月，Quantity就是2。如果计费单位是“按月”，并且Quantity为0，表示“购买到月底”
	Quantity *int `required:"false"`

	// 是否使用SSD，默认为false
	UseSSD *bool `required:"false"`

	// SSD类型，可选值为"SATA"、"PCI-E"，如果UseSSD为true ，则必填
	SSDType *string `required:"false"`

	// UDB实例的DB版本字符串, 默认值为mysql-5.6
	DBTypeId *string `required:"false"`

	// 实例的部署类型。可选值为：Normal: 普通单点实例，HA: 高可用部署实例，默认是Normal
	InstanceMode *string `required:"false"`
}

// DescribeUDBInstancePriceResponse is response schema for DescribeUDBInstancePrice action
type DescribeUDBInstancePriceResponse struct {
	response.CommonBase

	// 价格 参照UDBInstancePriceSet
	DataSet []UDBInstancePriceSet
}

// NewDescribeUDBInstancePriceRequest will create request of DescribeUDBInstancePrice action.
func (c *UDBClient) NewDescribeUDBInstancePriceRequest() *DescribeUDBInstancePriceRequest {
	req := &DescribeUDBInstancePriceRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeUDBInstancePrice - 获取UDB实例价格信息
func (c *UDBClient) DescribeUDBInstancePrice(req *DescribeUDBInstancePriceRequest) (*DescribeUDBInstancePriceResponse, error) {
	var err error
	var res DescribeUDBInstancePriceResponse

	err = c.Client.InvokeAction("DescribeUDBInstancePrice", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
