//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UDB DescribeUDBParamGroup

package udb

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// DescribeUDBParamGroupRequest is request schema for DescribeUDBParamGroup action
type DescribeUDBParamGroupRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// [公共参数] 可用区。参见 [可用区列表](../summary/regionlist.html)
	// Zone *string `required:"false"`

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// 分页显示的起始偏移，列表操作则指定
	Offset *int `required:"true"`

	// 分页显示的条目数，列表操作则指定
	Limit *int `required:"true"`

	// 参数组id，如果指定则获取描述，否则是列表操作，需要 指定Offset/Limit
	GroupId *int `required:"false"`

	// 是否选取专区中配置
	IsInUDBC *bool `required:"false"`

	// 当请求没有填写Zone时，如果指定为true，表示只拉取跨可用区的相关配置文件，否则，拉取所有机房的配置文件（包括每个单可用区和跨可用区）
	RegionFlag *bool `required:"false"`

	// 如果未指定GroupId，则可选是否选取特定DB类型的配置(sql, nosql, postgresql, sqlserver)
	ClassType *string `required:"false"`
}

// DescribeUDBParamGroupResponse is response schema for DescribeUDBParamGroup action
type DescribeUDBParamGroupResponse struct {
	response.CommonBase

	// 参数组列表 参照UDBParamGroupSet
	DataSet []UDBParamGroupSet

	// 参数组总数，列表操作时才会有该参数
	TotalCount int
}

// NewDescribeUDBParamGroupRequest will create request of DescribeUDBParamGroup action.
func (c *UDBClient) NewDescribeUDBParamGroupRequest() *DescribeUDBParamGroupRequest {
	req := &DescribeUDBParamGroupRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

// DescribeUDBParamGroup - 获取参数组详细参数信息
func (c *UDBClient) DescribeUDBParamGroup(req *DescribeUDBParamGroupRequest) (*DescribeUDBParamGroupResponse, error) {
	var err error
	var res DescribeUDBParamGroupResponse

	err = c.Client.InvokeAction("DescribeUDBParamGroup", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
