//Code is generated by ucloud code generator, don't modify it by hand, it will cause undefined behaviors.
//go:generate ucloud-gen-go-api UDPN AllocateUDPN

package udpn

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// AllocateUDPNRequest is request schema for AllocateUDPN action
type AllocateUDPNRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"false"`

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// 专线可用区1，支持地域：北京二：cn-bj2, 上海二：cn-sh2, 广东：cn-gd, 亚太： hk, 上海一：cn-sh1, 法兰克福：ge-fra, 新加坡：sg,  洛杉矶：us-la， 华盛顿：us-ws， 东京：jpn-tky
	Peer1 *string `required:"true"`

	// 专线可用区2，支持地域：北京二：cn-bj2, 上海二：cn-sh2, 广东：cn-gd, 亚太： hk, 上海一：cn-sh1, 法兰克福：ge-fra, 新加坡：sg,  洛杉矶：us-la， 华盛顿：us-ws， 东京：jpn-tky
	Peer2 *string `required:"true"`

	// 带宽
	Bandwidth *int `required:"true"`

	// 计费类型，枚举值为： Year，按年付费； Month，按月付费； Dynamic，按需付费
	ChargeType *string `required:"false"`

	// 计费时长，默认 1
	Quantity *int `required:"false"`

	// 代金劵
	CouponId *string `required:"false"`
}

// AllocateUDPNResponse is response schema for AllocateUDPN action
type AllocateUDPNResponse struct {
	response.CommonBase

	// 资源名称
	UDPNId string
}

// NewAllocateUDPNRequest will create request of AllocateUDPN action.
func (c *UDPNClient) NewAllocateUDPNRequest() *AllocateUDPNRequest {
	req := &AllocateUDPNRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

// AllocateUDPN - 分配一条 UDPN 专线
func (c *UDPNClient) AllocateUDPN(req *AllocateUDPNRequest) (*AllocateUDPNResponse, error) {
	var err error
	var res AllocateUDPNResponse

	err = c.Client.InvokeAction("AllocateUDPN", req, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
