// Code is generated by ucloud-model, DO NOT EDIT IT.

package ulb

import (
	"github.com/ucloud/ucloud-sdk-go/ucloud/request"
	"github.com/ucloud/ucloud-sdk-go/ucloud/response"
)

// ULB API Schema

// AllocateBackendRequest is request schema for AllocateBackend action
type AllocateBackendRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 后端实例状态开关，枚举值： 1：启用； 0：禁用 默认为启用
	Enabled *int `required:"false"`

	// rs是否为backup，默认为00：普通rs1：backup的rs
	IsBackup *int `required:"false"`

	// 所添加的后端资源服务端口，取值范围[1-65535]，默认80
	Port *int `required:"false"`

	// 所添加的后端服务器的资源实例IP，当ResourceType 为 UHybrid 时有效，且必填
	ResourceIP *string `required:"false"`

	// 所添加的后端资源的资源ID
	ResourceId *string `required:"true"`

	// 所添加的后端资源的类型，枚举值：UHost -> 云主机；UPM -> 物理云主机； UDHost -> 私有专区主机；UDocker -> 容器；UHybrid->混合云主机；CUBE->Cube；默认值为UHost。报文转发模式不支持UDocker、UHybrid、CUBE
	ResourceType *string `required:"true"`

	// 所添加的后端服务器所在的子网，当ResourceType 为 UHybrid 时有效，且必填
	SubnetId *string `required:"false"`

	// 负载均衡实例的ID
	ULBId *string `required:"true"`

	// 所添加的后端服务器所在的vpc，当ResourceType 为 UHybrid 时有效，且必填
	VPCId *string `required:"false"`

	// VServer实例的ID
	VServerId *string `required:"true"`

	// 所添加的后端RS权重（在加权轮询算法下有效），取值范围[0-100]，默认为1
	Weight *int `required:"false"`
}

// AllocateBackendResponse is response schema for AllocateBackend action
type AllocateBackendResponse struct {
	response.CommonBase

	// 所添加的后端资源在ULB中的对象ID，（为ULB系统中使用，与资源自身ID无关），可用于 UpdateBackendAttribute/UpdateBackendAttributeBatch/ReleaseBackend
	BackendId string
}

// NewAllocateBackendRequest will create request of AllocateBackend action.
func (c *ULBClient) NewAllocateBackendRequest() *AllocateBackendRequest {
	req := &AllocateBackendRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

/*
API: AllocateBackend

添加ULB后端资源实例
*/
func (c *ULBClient) AllocateBackend(req *AllocateBackendRequest) (*AllocateBackendResponse, error) {
	var err error
	var res AllocateBackendResponse

	reqCopier := *req

	err = c.Client.InvokeAction("AllocateBackend", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// AllocateBackendBatchRequest is request schema for AllocateBackendBatch action
type AllocateBackendBatchRequest struct {
	request.CommonBase

	//
	ApiVersion *int `required:"false"`

	//
	Backends []string `required:"true"`

	//
	ULBId *string `required:"true"`

	//
	VServerId *string `required:"true"`
}

// AllocateBackendBatchResponse is response schema for AllocateBackendBatch action
type AllocateBackendBatchResponse struct {
	response.CommonBase

	//
	BackendSet []BackendSet
}

// NewAllocateBackendBatchRequest will create request of AllocateBackendBatch action.
func (c *ULBClient) NewAllocateBackendBatchRequest() *AllocateBackendBatchRequest {
	req := &AllocateBackendBatchRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

/*
API: AllocateBackendBatch


*/
func (c *ULBClient) AllocateBackendBatch(req *AllocateBackendBatchRequest) (*AllocateBackendBatchResponse, error) {
	var err error
	var res AllocateBackendBatchResponse

	reqCopier := *req

	err = c.Client.InvokeAction("AllocateBackendBatch", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// BindSSLRequest is request schema for BindSSL action
type BindSSLRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// SSL证书的Id
	SSLId *string `required:"true"`

	// 所绑定ULB实例ID
	ULBId *string `required:"true"`

	// 所绑定VServer实例ID
	VServerId *string `required:"true"`
}

// BindSSLResponse is response schema for BindSSL action
type BindSSLResponse struct {
	response.CommonBase
}

// NewBindSSLRequest will create request of BindSSL action.
func (c *ULBClient) NewBindSSLRequest() *BindSSLRequest {
	req := &BindSSLRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: BindSSL

将SSL证书绑定到VServer
*/
func (c *ULBClient) BindSSL(req *BindSSLRequest) (*BindSSLResponse, error) {
	var err error
	var res BindSSLResponse

	reqCopier := *req

	err = c.Client.InvokeAction("BindSSL", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// CreatePolicyRequest is request schema for CreatePolicy action
type CreatePolicyRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 内容转发策略应用的后端资源实例的ID，来源于 AllocateBackend 返回的 BackendId
	BackendId []string `required:"true"`

	// 内容转发匹配字段
	Match *string `required:"true"`

	// 内容转发匹配字段的类型
	Type *string `required:"false"`

	// 需要添加内容转发策略的负载均衡实例ID
	ULBId *string `required:"true"`

	// 需要添加内容转发策略的VServer实例ID
	VServerId *string `required:"true"`
}

// CreatePolicyResponse is response schema for CreatePolicy action
type CreatePolicyResponse struct {
	response.CommonBase

	// 内容转发策略ID
	PolicyId string
}

// NewCreatePolicyRequest will create request of CreatePolicy action.
func (c *ULBClient) NewCreatePolicyRequest() *CreatePolicyRequest {
	req := &CreatePolicyRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

/*
API: CreatePolicy

创建VServer内容转发策略
*/
func (c *ULBClient) CreatePolicy(req *CreatePolicyRequest) (*CreatePolicyResponse, error) {
	var err error
	var res CreatePolicyResponse

	reqCopier := *req

	err = c.Client.InvokeAction("CreatePolicy", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// CreatePolicyGroupRequest is request schema for CreatePolicyGroup action
type CreatePolicyGroupRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 内容转发策略组名称，默认为空
	GroupName *string `required:"false"`
}

// CreatePolicyGroupResponse is response schema for CreatePolicyGroup action
type CreatePolicyGroupResponse struct {
	response.CommonBase

	// 内容转发策略组的Id
	GroupId string
}

// NewCreatePolicyGroupRequest will create request of CreatePolicyGroup action.
func (c *ULBClient) NewCreatePolicyGroupRequest() *CreatePolicyGroupRequest {
	req := &CreatePolicyGroupRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

/*
API: CreatePolicyGroup

创建内容转发策略组
*/
func (c *ULBClient) CreatePolicyGroup(req *CreatePolicyGroupRequest) (*CreatePolicyGroupResponse, error) {
	var err error
	var res CreatePolicyGroupResponse

	reqCopier := *req

	err = c.Client.InvokeAction("CreatePolicyGroup", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// CreateSSLRequest is request schema for CreateSSL action
type CreateSSLRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// CA证书
	CaCert *string `required:"false"`

	// 加密证书的私钥
	PrivateKey *string `required:"false"`

	// SSL证书的完整内容，包括用户证书、加密证书的私钥、CA证书
	SSLContent *string `required:"false"`

	// SSL证书的名字，默认值为空
	SSLName *string `required:"true"`

	// 所添加的SSL证书类型，目前只支持Pem格式
	SSLType *string `required:"false"`

	// 用户的证书
	UserCert *string `required:"false"`
}

// CreateSSLResponse is response schema for CreateSSL action
type CreateSSLResponse struct {
	response.CommonBase

	// SSL证书的Id
	SSLId string
}

// NewCreateSSLRequest will create request of CreateSSL action.
func (c *ULBClient) NewCreateSSLRequest() *CreateSSLRequest {
	req := &CreateSSLRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

/*
API: CreateSSL

创建SSL证书，可以把整个 Pem 证书内容传过来，或者把证书、私钥、CA证书分别传过来
*/
func (c *ULBClient) CreateSSL(req *CreateSSLRequest) (*CreateSSLResponse, error) {
	var err error
	var res CreateSSLResponse

	reqCopier := *req

	err = c.Client.InvokeAction("CreateSSL", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// CreateULBRequest is request schema for CreateULB action
type CreateULBRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// ULB 所属的业务组ID，如果不传则使用默认的业务组
	BusinessId *string `required:"false"`

	// 付费方式, 枚举值为: Year, 按年付费; Month, 按月付费; Dynamic, 按时付费
	ChargeType *string `required:"false"`

	// 防火墙ID，如果不传，则默认不绑定防火墙
	FirewallId *string `required:"false"`

	// 创建的ULB是否为内网模式
	InnerMode *string `required:"false"`

	// ULB 监听器类型，枚举值：RequestProxy，请求代理； PacketsTransmit ，报文转发。默认为RequestProxy
	ListenType *string `required:"false"`

	// 创建的ULB是否为外网模式，默认即为外网模式
	OuterMode *string `required:"false"`

	// 【该字段已废弃，请谨慎使用】
	PrivateIp *string `required:"false" deprecated:"true"`

	// 备注
	Remark *string `required:"false"`

	// 内网ULB 所属的子网ID，如果不传则使用默认的子网
	SubnetId *string `required:"false"`

	// 业务组
	Tag *string `required:"false"`

	// 负载均衡的名字，默认值为“ULB”
	ULBName *string `required:"false"`

	// ULB所在的VPC的ID, 如果不传则使用默认的VPC
	VPCId *string `required:"false"`
}

// CreateULBResponse is response schema for CreateULB action
type CreateULBResponse struct {
	response.CommonBase

	// IPv6地址Id
	IPv6AddressId string

	// 负载均衡实例的Id
	ULBId string
}

// NewCreateULBRequest will create request of CreateULB action.
func (c *ULBClient) NewCreateULBRequest() *CreateULBRequest {
	req := &CreateULBRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

/*
API: CreateULB

创建负载均衡实例，可以选择内网或者外网
*/
func (c *ULBClient) CreateULB(req *CreateULBRequest) (*CreateULBResponse, error) {
	var err error
	var res CreateULBResponse

	reqCopier := *req

	err = c.Client.InvokeAction("CreateULB", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// CreateVServerRequest is request schema for CreateVServer action
type CreateVServerRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// ListenType为RequestProxy时表示空闲连接的回收时间，单位：秒，取值范围：时(0，86400]，默认值为60；ListenType为PacketsTransmit时表示连接保持的时间，单位：秒，取值范围：[60，900]，0 表示禁用连接保持
	ClientTimeout *int `required:"false"`

	// 根据MonitorType确认； 当MonitorType为Path时，此字段有意义，代表HTTP检查域名
	Domain *string `required:"false"`

	// VServer后端端口，取值范围[1-65535]；默认值为80
	FrontendPort *int `required:"false"`

	// 监听器类型，枚举值，RequestProxy ，请求代理；PacketsTransmit ，报文转发。默认为RequestProxy
	ListenType *string `required:"false"`

	// VServer负载均衡模式，枚举值：Roundrobin -> 轮询;Source -> 源地址；ConsistentHash -> 一致性哈希；SourcePort -> 源地址（计算端口）；ConsistentHashPort -> 一致性哈希（计算端口）; WeightRoundrobin -> 加权轮询; Leastconn -> 最小连接数;Backup ->主备模式。ConsistentHash，SourcePort，ConsistentHashPort 只在报文转发中使用；Leastconn只在请求代理中使用；Roundrobin、Source和WeightRoundrobin,Backup在请求代理和报文转发中使用。默认为："Roundrobin"
	Method *string `required:"false"`

	// 健康检查类型，枚举值：Port -> 端口检查；Path -> 路径检查；Ping -> Ping探测，请求代理型默认值为Port，其中TCP协议仅支持Port，其他协议支持Port和Path;报文转发型TCP协议仅支持Port，UDP协议支持Ping和Port，默认值为Ping
	MonitorType *string `required:"false"`

	// 根据MonitorType确认； 当MonitorType为Path时，此字段有意义，代表HTTP检查路径
	Path *string `required:"false"`

	// 根据PersistenceType确认； None和ServerInsert： 此字段无意义； UserDefined：此字段传入自定义会话保持String
	PersistenceInfo *string `required:"false"`

	// VServer会话保持方式，默认关闭会话保持。枚举值：None -> 关闭；ServerInsert -> 自动生成KEY；UserDefined -> 用户自定义KEY。
	PersistenceType *string `required:"false"`

	// VServer实例的协议，请求代理模式下有 HTTP、HTTPS、TCP，报文转发下有 TCP，UDP。默认为“HTTP"
	Protocol *string `required:"false"`

	// 负载均衡实例ID
	ULBId *string `required:"true"`

	// VServer实例名称，默认为"VServer"
	VServerName *string `required:"false"`
}

// CreateVServerResponse is response schema for CreateVServer action
type CreateVServerResponse struct {
	response.CommonBase

	// VServer实例的Id
	VServerId string
}

// NewCreateVServerRequest will create request of CreateVServer action.
func (c *ULBClient) NewCreateVServerRequest() *CreateVServerRequest {
	req := &CreateVServerRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(false)
	return req
}

/*
API: CreateVServer

创建VServer实例，定义监听的协议和端口以及负载均衡算法
*/
func (c *ULBClient) CreateVServer(req *CreateVServerRequest) (*CreateVServerResponse, error) {
	var err error
	var res CreateVServerResponse

	reqCopier := *req

	err = c.Client.InvokeAction("CreateVServer", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DeletePolicyRequest is request schema for DeletePolicy action
type DeletePolicyRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 内容转发策略组ID
	GroupId *string `required:"false"`

	// 内容转发策略ID
	PolicyId *string `required:"true"`

	// VServer 资源ID
	VServerId *string `required:"false"`
}

// DeletePolicyResponse is response schema for DeletePolicy action
type DeletePolicyResponse struct {
	response.CommonBase
}

// NewDeletePolicyRequest will create request of DeletePolicy action.
func (c *ULBClient) NewDeletePolicyRequest() *DeletePolicyRequest {
	req := &DeletePolicyRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DeletePolicy

删除内容转发策略
*/
func (c *ULBClient) DeletePolicy(req *DeletePolicyRequest) (*DeletePolicyResponse, error) {
	var err error
	var res DeletePolicyResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DeletePolicy", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DeletePolicyGroupRequest is request schema for DeletePolicyGroup action
type DeletePolicyGroupRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 内容转发策略组ID
	GroupId *string `required:"true"`
}

// DeletePolicyGroupResponse is response schema for DeletePolicyGroup action
type DeletePolicyGroupResponse struct {
	response.CommonBase
}

// NewDeletePolicyGroupRequest will create request of DeletePolicyGroup action.
func (c *ULBClient) NewDeletePolicyGroupRequest() *DeletePolicyGroupRequest {
	req := &DeletePolicyGroupRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DeletePolicyGroup

删除内容转发策略组
*/
func (c *ULBClient) DeletePolicyGroup(req *DeletePolicyGroupRequest) (*DeletePolicyGroupResponse, error) {
	var err error
	var res DeletePolicyGroupResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DeletePolicyGroup", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DeleteSSLRequest is request schema for DeleteSSL action
type DeleteSSLRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// SSL证书的ID
	SSLId *string `required:"true"`
}

// DeleteSSLResponse is response schema for DeleteSSL action
type DeleteSSLResponse struct {
	response.CommonBase
}

// NewDeleteSSLRequest will create request of DeleteSSL action.
func (c *ULBClient) NewDeleteSSLRequest() *DeleteSSLRequest {
	req := &DeleteSSLRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DeleteSSL

删除SSL证书
*/
func (c *ULBClient) DeleteSSL(req *DeleteSSLRequest) (*DeleteSSLResponse, error) {
	var err error
	var res DeleteSSLResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DeleteSSL", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DeleteULBRequest is request schema for DeleteULB action
type DeleteULBRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 删除ulb时是否释放绑定的EIP，false标识只解绑EIP，true表示会释放绑定的EIP，默认是false。Anycast IP 此参数无效
	ReleaseEip *bool `required:"false"`

	// 负载均衡实例的ID
	ULBId *string `required:"true"`
}

// DeleteULBResponse is response schema for DeleteULB action
type DeleteULBResponse struct {
	response.CommonBase
}

// NewDeleteULBRequest will create request of DeleteULB action.
func (c *ULBClient) NewDeleteULBRequest() *DeleteULBRequest {
	req := &DeleteULBRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DeleteULB

删除负载均衡实例
*/
func (c *ULBClient) DeleteULB(req *DeleteULBRequest) (*DeleteULBResponse, error) {
	var err error
	var res DeleteULBResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DeleteULB", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DeleteVServerRequest is request schema for DeleteVServer action
type DeleteVServerRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 负载均衡实例的ID
	ULBId *string `required:"true"`

	// VServer实例的ID
	VServerId *string `required:"true"`
}

// DeleteVServerResponse is response schema for DeleteVServer action
type DeleteVServerResponse struct {
	response.CommonBase
}

// NewDeleteVServerRequest will create request of DeleteVServer action.
func (c *ULBClient) NewDeleteVServerRequest() *DeleteVServerRequest {
	req := &DeleteVServerRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DeleteVServer

删除VServer实例
*/
func (c *ULBClient) DeleteVServer(req *DeleteVServerRequest) (*DeleteVServerResponse, error) {
	var err error
	var res DeleteVServerResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DeleteVServer", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DescribePolicyGroupRequest is request schema for DescribePolicyGroup action
type DescribePolicyGroupRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 内容转发策略组ID
	GroupId *string `required:"false"`

	// 数据分页值，默认为20
	Limit *int `required:"false"`

	// 数据偏移量，默认值为0
	Offset *int `required:"false"`
}

// DescribePolicyGroupResponse is response schema for DescribePolicyGroup action
type DescribePolicyGroupResponse struct {
	response.CommonBase

	// 内容转发策略组列表，具体结构见 UlbPolicyGroupSet
	DataSet []UlbPolicyGroupSet
}

// NewDescribePolicyGroupRequest will create request of DescribePolicyGroup action.
func (c *ULBClient) NewDescribePolicyGroupRequest() *DescribePolicyGroupRequest {
	req := &DescribePolicyGroupRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DescribePolicyGroup

获取内容转发组详细信息
*/
func (c *ULBClient) DescribePolicyGroup(req *DescribePolicyGroupRequest) (*DescribePolicyGroupResponse, error) {
	var err error
	var res DescribePolicyGroupResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribePolicyGroup", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DescribeSSLRequest is request schema for DescribeSSL action
type DescribeSSLRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 数据分页值，默认为20
	Limit *int `required:"false"`

	// 数据偏移量，默认值为0
	Offset *int `required:"false"`

	// SSL证书的Id
	SSLId *string `required:"false"`
}

// DescribeSSLResponse is response schema for DescribeSSL action
type DescribeSSLResponse struct {
	response.CommonBase

	// SSL证书详细信息，具体结构见 ULBSSLSet
	DataSet []ULBSSLSet

	// 满足条件的SSL证书总数
	TotalCount int
}

// NewDescribeSSLRequest will create request of DescribeSSL action.
func (c *ULBClient) NewDescribeSSLRequest() *DescribeSSLRequest {
	req := &DescribeSSLRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DescribeSSL

获取SSL证书信息
*/
func (c *ULBClient) DescribeSSL(req *DescribeSSLRequest) (*DescribeSSLResponse, error) {
	var err error
	var res DescribeSSLResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribeSSL", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DescribeULBRequest is request schema for DescribeULB action
type DescribeULBRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// ULB所属的业务组ID
	BusinessId *string `required:"false"`

	// 数据分页值，默认为20
	Limit *int `required:"false"`

	// 数据偏移量，默认为0
	Offset *int `required:"false"`

	// ULB所属的子网ID
	SubnetId *string `required:"false"`

	// 负载均衡实例的Id。 若指定则返回指定的负载均衡实例的信息； 若不指定则返回当前数据中心中所有的负载均衡实例的信息
	ULBId *string `required:"false"`

	// ULB所属的VPC
	VPCId *string `required:"false"`
}

// DescribeULBResponse is response schema for DescribeULB action
type DescribeULBResponse struct {
	response.CommonBase

	// ULB列表，每项参数详见 ULBSet
	DataSet []ULBSet

	// 满足条件的ULB总数
	TotalCount int
}

// NewDescribeULBRequest will create request of DescribeULB action.
func (c *ULBClient) NewDescribeULBRequest() *DescribeULBRequest {
	req := &DescribeULBRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DescribeULB

获取ULB详细信息
*/
func (c *ULBClient) DescribeULB(req *DescribeULBRequest) (*DescribeULBResponse, error) {
	var err error
	var res DescribeULBResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribeULB", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DescribeULBSimpleRequest is request schema for DescribeULBSimple action
type DescribeULBSimpleRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"false"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// ULB所属的业务组ID
	BusinessId *string `required:"false"`

	// 数据分页值，默认为10000
	Limit *int `required:"false"`

	// 数据偏移量，默认为0
	Offset *int `required:"false"`

	// ULB所属的子网ID
	SubnetId *string `required:"false"`

	// 负载均衡实例的Id。 若指定则返回指定的负载均衡实例的信息； 若不指定则返回当前数据中心中所有的负载均衡实例的信息
	ULBId *string `required:"false"`

	// ULB所属的VPC
	VPCId *string `required:"false"`
}

// DescribeULBSimpleResponse is response schema for DescribeULBSimple action
type DescribeULBSimpleResponse struct {
	response.CommonBase

	// ULB列表，每项参数详见 ULBSimpleSet
	DataSet []ULBSimpleSet

	// 满足条件的ULB总数
	TotalCount int
}

// NewDescribeULBSimpleRequest will create request of DescribeULBSimple action.
func (c *ULBClient) NewDescribeULBSimpleRequest() *DescribeULBSimpleRequest {
	req := &DescribeULBSimpleRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DescribeULBSimple

获取ULB信息
*/
func (c *ULBClient) DescribeULBSimple(req *DescribeULBSimpleRequest) (*DescribeULBSimpleResponse, error) {
	var err error
	var res DescribeULBSimpleResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribeULBSimple", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// DescribeVServerRequest is request schema for DescribeVServer action
type DescribeVServerRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 数据分页值
	Limit *int `required:"false"`

	// 数据偏移量
	Offset *int `required:"false"`

	// 负载均衡实例的Id
	ULBId *string `required:"true"`

	// VServer实例的Id；若指定则返回指定的VServer实例的信息； 若不指定则返回当前负载均衡实例下所有VServer的信息
	VServerId *string `required:"false"`
}

// DescribeVServerResponse is response schema for DescribeVServer action
type DescribeVServerResponse struct {
	response.CommonBase

	// VServer列表，每项参数详见 ULBVServerSet
	DataSet []ULBVServerSet

	// 满足条件的VServer总数
	TotalCount int
}

// NewDescribeVServerRequest will create request of DescribeVServer action.
func (c *ULBClient) NewDescribeVServerRequest() *DescribeVServerRequest {
	req := &DescribeVServerRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: DescribeVServer

获取ULB下的VServer的详细信息
*/
func (c *ULBClient) DescribeVServer(req *DescribeVServerRequest) (*DescribeVServerResponse, error) {
	var err error
	var res DescribeVServerResponse

	reqCopier := *req

	err = c.Client.InvokeAction("DescribeVServer", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// ReleaseBackendRequest is request schema for ReleaseBackend action
type ReleaseBackendRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 后端资源实例的ID(ULB后端ID，非资源自身ID)
	BackendId *string `required:"true"`

	// 负载均衡实例的ID
	ULBId *string `required:"true"`
}

// ReleaseBackendResponse is response schema for ReleaseBackend action
type ReleaseBackendResponse struct {
	response.CommonBase
}

// NewReleaseBackendRequest will create request of ReleaseBackend action.
func (c *ULBClient) NewReleaseBackendRequest() *ReleaseBackendRequest {
	req := &ReleaseBackendRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: ReleaseBackend

从VServer释放后端资源实例
*/
func (c *ULBClient) ReleaseBackend(req *ReleaseBackendRequest) (*ReleaseBackendResponse, error) {
	var err error
	var res ReleaseBackendResponse

	reqCopier := *req

	err = c.Client.InvokeAction("ReleaseBackend", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// UnbindSSLRequest is request schema for UnbindSSL action
type UnbindSSLRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// SSL证书的Id
	SSLId *string `required:"true"`

	// 所绑定ULB实例ID
	ULBId *string `required:"true"`

	// 所绑定VServer实例ID
	VServerId *string `required:"true"`
}

// UnbindSSLResponse is response schema for UnbindSSL action
type UnbindSSLResponse struct {
	response.CommonBase
}

// NewUnbindSSLRequest will create request of UnbindSSL action.
func (c *ULBClient) NewUnbindSSLRequest() *UnbindSSLRequest {
	req := &UnbindSSLRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: UnbindSSL

从VServer解绑SSL证书
*/
func (c *ULBClient) UnbindSSL(req *UnbindSSLRequest) (*UnbindSSLResponse, error) {
	var err error
	var res UnbindSSLResponse

	reqCopier := *req

	err = c.Client.InvokeAction("UnbindSSL", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// UpdateBackendAttributeRequest is request schema for UpdateBackendAttribute action
type UpdateBackendAttributeRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 后端资源实例的ID(ULB后端ID，非资源自身ID)
	BackendId *string `required:"true"`

	// 后端实例状态开关
	Enabled *int `required:"false"`

	// 后端资源服务端口，取值范围[1-65535]
	Port *int `required:"false"`

	// 负载均衡资源ID
	ULBId *string `required:"true"`

	// 所添加的后端RS权重（在加权轮询算法下有效），取值范围[0-100]，默认为1
	Weight *int `required:"false"`
}

// UpdateBackendAttributeResponse is response schema for UpdateBackendAttribute action
type UpdateBackendAttributeResponse struct {
	response.CommonBase
}

// NewUpdateBackendAttributeRequest will create request of UpdateBackendAttribute action.
func (c *ULBClient) NewUpdateBackendAttributeRequest() *UpdateBackendAttributeRequest {
	req := &UpdateBackendAttributeRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: UpdateBackendAttribute

更新ULB后端资源实例(服务节点)属性
*/
func (c *ULBClient) UpdateBackendAttribute(req *UpdateBackendAttributeRequest) (*UpdateBackendAttributeResponse, error) {
	var err error
	var res UpdateBackendAttributeResponse

	reqCopier := *req

	err = c.Client.InvokeAction("UpdateBackendAttribute", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// UpdatePolicyRequest is request schema for UpdatePolicy action
type UpdatePolicyRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 内容转发策略应用的后端资源实例的ID，来源于 AllocateBackend 返回的 BackendId，不传表示更新转发节点为空
	BackendId []string `required:"false"`

	// 内容转发匹配字段
	Match *string `required:"true"`

	// 转发规则的ID，当Type为Default时，可以不传或为空
	PolicyId *string `required:"false"`

	// 内容转发匹配字段的类型，枚举值：Domain -> 域名转发规则；Path -> 路径转发规则；Default -> 默认转发规则，不传默认值Domain
	Type *string `required:"false"`

	// 需要添加内容转发策略的负载均衡实例ID
	ULBId *string `required:"true"`

	// 需要添加内容转发策略的VServer实例ID，只支持请求代理模式下，HTTP或HTTPS协议的VServer
	VServerId *string `required:"true"`
}

// UpdatePolicyResponse is response schema for UpdatePolicy action
type UpdatePolicyResponse struct {
	response.CommonBase

	// 转发规则的ID
	PolicyId string
}

// NewUpdatePolicyRequest will create request of UpdatePolicy action.
func (c *ULBClient) NewUpdatePolicyRequest() *UpdatePolicyRequest {
	req := &UpdatePolicyRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: UpdatePolicy

更新内容转发规则，包括转发规则后的服务节点
*/
func (c *ULBClient) UpdatePolicy(req *UpdatePolicyRequest) (*UpdatePolicyResponse, error) {
	var err error
	var res UpdatePolicyResponse

	reqCopier := *req

	err = c.Client.InvokeAction("UpdatePolicy", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// UpdatePolicyGroupAttributeRequest is request schema for UpdatePolicyGroupAttribute action
type UpdatePolicyGroupAttributeRequest struct {
	request.CommonBase

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 内容转发策略组ID
	GroupId *string `required:"true"`

	// 修改策略转发组名称
	GroupName *string `required:"false"`
}

// UpdatePolicyGroupAttributeResponse is response schema for UpdatePolicyGroupAttribute action
type UpdatePolicyGroupAttributeResponse struct {
	response.CommonBase
}

// NewUpdatePolicyGroupAttributeRequest will create request of UpdatePolicyGroupAttribute action.
func (c *ULBClient) NewUpdatePolicyGroupAttributeRequest() *UpdatePolicyGroupAttributeRequest {
	req := &UpdatePolicyGroupAttributeRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: UpdatePolicyGroupAttribute

更新内容转发策略组属性
*/
func (c *ULBClient) UpdatePolicyGroupAttribute(req *UpdatePolicyGroupAttributeRequest) (*UpdatePolicyGroupAttributeResponse, error) {
	var err error
	var res UpdatePolicyGroupAttributeResponse

	reqCopier := *req

	err = c.Client.InvokeAction("UpdatePolicyGroupAttribute", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// UpdateULBAttributeRequest is request schema for UpdateULBAttribute action
type UpdateULBAttributeRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 名字
	Name *string `required:"false"`

	// 备注
	Remark *string `required:"false"`

	// 业务
	Tag *string `required:"false"`

	// ULB资源ID
	ULBId *string `required:"true"`
}

// UpdateULBAttributeResponse is response schema for UpdateULBAttribute action
type UpdateULBAttributeResponse struct {
	response.CommonBase
}

// NewUpdateULBAttributeRequest will create request of UpdateULBAttribute action.
func (c *ULBClient) NewUpdateULBAttributeRequest() *UpdateULBAttributeRequest {
	req := &UpdateULBAttributeRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: UpdateULBAttribute

更新ULB名字业务组备注等属性字段
*/
func (c *ULBClient) UpdateULBAttribute(req *UpdateULBAttributeRequest) (*UpdateULBAttributeResponse, error) {
	var err error
	var res UpdateULBAttributeResponse

	reqCopier := *req

	err = c.Client.InvokeAction("UpdateULBAttribute", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}

// UpdateVServerAttributeRequest is request schema for UpdateVServerAttribute action
type UpdateVServerAttributeRequest struct {
	request.CommonBase

	// [公共参数] 项目ID。不填写为默认项目，子帐号必须填写。 请参考[GetProjectList接口](../summary/get_project_list.html)
	// ProjectId *string `required:"true"`

	// [公共参数] 地域。 参见 [地域和可用区列表](../summary/regionlist.html)
	// Region *string `required:"true"`

	// 请求代理的VServer下表示空闲连接的回收时间，单位：秒，取值范围：时(0，86400]，默认值为60；报文转发的VServer下表示回话保持的时间，单位：秒，取值范围：[60，900]，0 表示禁用连接保持
	ClientTimeout *int `required:"false"`

	// MonitorType 为 Path 时指定健康检查发送请求时HTTP HEADER 里的域名
	Domain *string `required:"false"`

	// VServer负载均衡模式，枚举值：Roundrobin -> 轮询;Source -> 源地址；ConsistentHash -> 一致性哈希；SourcePort -> 源地址（计算端口）；ConsistentHashPort -> 一致性哈希（计算端口）; WeightRoundrobin -> 加权轮询; Leastconn -> 最小连接数；Backup -> 主备模式。ConsistentHash，SourcePort，ConsistentHashPort 只在报文转发中使用；Leastconn只在请求代理中使用；Roundrobin、Source和WeightRoundrobin,Backup在请求代理和报文转发中使用。默认为："Roundrobin"
	Method *string `required:"false"`

	// 健康检查类型，枚举值：Port -> 端口检查；Path -> 路径检查；Ping -> Ping探测，请求代理型默认值为Port，其中TCP协议仅支持Port，其他协议支持Port和Path;报文转发型TCP协议仅支持Port，UDP协议支持Ping和Port，默认值为Ping
	MonitorType *string `required:"false"`

	// MonitorType 为 Path 时指定健康检查发送请求时的路径，默认为 /
	Path *string `required:"false"`

	// 根据PersistenceType确定: None或ServerInsert, 此字段无意义; UserDefined, 则此字段传入用户自定义会话保持String. 若无此字段则不做修改
	PersistenceInfo *string `required:"false"`

	// VServer会话保持模式，若无此字段则不做修改。枚举值：None：关闭；ServerInsert：自动生成KEY；UserDefined：用户自定义KEY。
	PersistenceType *string `required:"false"`

	// 【该字段已废弃，请谨慎使用】
	Protocol *string `required:"false" deprecated:"true"`

	// 负载均衡实例ID
	ULBId *string `required:"true"`

	// VServer实例ID
	VServerId *string `required:"true"`

	// VServer实例名称，若无此字段则不做修改
	VServerName *string `required:"false"`
}

// UpdateVServerAttributeResponse is response schema for UpdateVServerAttribute action
type UpdateVServerAttributeResponse struct {
	response.CommonBase
}

// NewUpdateVServerAttributeRequest will create request of UpdateVServerAttribute action.
func (c *ULBClient) NewUpdateVServerAttributeRequest() *UpdateVServerAttributeRequest {
	req := &UpdateVServerAttributeRequest{}

	// setup request with client config
	c.Client.SetupRequest(req)

	// setup retryable with default retry policy (retry for non-create action and common error)
	req.SetRetryable(true)
	return req
}

/*
API: UpdateVServerAttribute

更新VServer实例属性
*/
func (c *ULBClient) UpdateVServerAttribute(req *UpdateVServerAttributeRequest) (*UpdateVServerAttributeResponse, error) {
	var err error
	var res UpdateVServerAttributeResponse

	reqCopier := *req

	err = c.Client.InvokeAction("UpdateVServerAttribute", &reqCopier, &res)
	if err != nil {
		return &res, err
	}

	return &res, nil
}
