// Code is generated by ucloud-model, DO NOT EDIT IT.

package umem

/*
UMemBackupSet - DescribeUMemBackup
*/
type UMemBackupSet struct {

	// 空间的备份ID
	BackupId string

	// 备份名称
	BackupName string

	// 备份类型: auto(自动) ,manual(手动)
	BackupType string

	// 本次备份，分片的数量
	BlockCount int

	// 创建时间
	CreateTime int

	// Starting:备份中 Done:完成
	State string
}

/*
UMemBlockInfo - 分布式redis 分片信息
*/
type UMemBlockInfo struct {

	// 分片id
	BlockId string

	// 分片端口
	BlockPort int

	// 容量单位GB
	BlockSize int

	// 分片维护的键槽起始值
	BlockSlotBegin int

	// 分片维护的键槽结束值
	BlockSlotEnd int

	// 实例状态 Starting // 创建中 Creating // 初始化中 CreateFail // 创建失败 Fail // 创建失败 Deleting // 删除中 DeleteFail // 删除失败 Running // 运行 Resizing // 容量调整中 ResizeFail // 容量调整失败 Configing // 配置中 ConfigFail // 配置失败Restarting // 重启中 SetPasswordFail //设置密码失败
	BlockState string

	// 使用量单位MB
	BlockUsedSize int

	// 分片ip
	BlockVip string
}

/*
UMemPriceSet - DescribeUMemPrice
*/
type UMemPriceSet struct {

	// Year， Month， Dynamic，Trial
	ChargeType string

	// 产品列表价
	ListPrice int

	// 原价
	OriginalPrice int

	// 现价
	Price int
}

/*
UMemSpaceAddressSet - DescribeUMemSpace
*/
type UMemSpaceAddressSet struct {

	// UMem实例访问IP
	IP string

	// UMem实例访问Port
	Port int
}

/*
UMemSpaceSet - DescribeUMemSpace
*/
type UMemSpaceSet struct {

	// IP端口信息请参见 UMemSpaceAddressSet
	Address []UMemSpaceAddressSet

	// Year, Month, Dynamic, Trial
	ChargeType string

	// 创建时间
	CreateTime int

	// 到期时间
	ExpireTime int

	// 内存空间名称
	Name string

	// 协议类型: memcache, redis
	Protocol string

	// 运维时间0   //0点1   //1点依次类推
	RewriteTime int

	// 容量单位GB
	Size int

	// 内存空间ID
	SpaceId string

	// Starting:创建中 Running:运行中 Fail:失败
	State string

	//
	SubnetId string

	//
	Tag string

	// 空间类型:single(无热备),double(热备)
	Type string

	// 使用量单位MB
	UsedSize int

	//
	VPCId string

	// 可用区，参见[可用区列表](../summary/regionlist.html)
	Zone string
}

/*
PriceDataSet - 升降级价格
*/
type PriceDataSet struct {

	// 用户折后价
	CustomPrice int

	// 资源有效期
	PurchaseValue int

	// 升降级资源的价格
	TotalPrice int
}

/*
UMemcacheGroupSet - DescribeUMemcacheGroup
*/
type UMemcacheGroupSet struct {

	// 计费类型:Year,Month,Dynamic 默认Dynamic
	ChargeType string

	// 节点的配置ID
	ConfigId string

	// 创建时间 (UNIX时间戳)
	CreateTime int

	// 过期时间 (UNIX时间戳)
	ExpireTime int

	// 组ID
	GroupId string

	// 修改时间 (UNIX时间戳)
	ModifyTime int

	// 组名称
	Name string

	// 节点分配的服务端口
	Port int

	// 容量单位GB
	Size int

	// 状态标记 Creating // 初始化中 CreateFail // 创建失败 Deleting // 删除中 DeleteFail // 删除失败 Running // 运行 Resizing // 容量调整中 ResizeFail // 容量调整失败 Configing // 配置中 ConfigFail // 配置失败Restarting // 重启中
	State string

	//
	SubnetId string

	// 业务组名称
	Tag string

	// 使用量单位MB
	UsedSize int

	//
	VPCId string

	// Memcache版本信息,默认为1.4.31
	Version string

	// 节点的虚拟IP地址
	VirtualIP string
}

/*
UMemcachePriceSet - DescribeUMemcachePrice
*/
type UMemcachePriceSet struct {

	// 计费模式，Year, Month, Dynamic
	ChargeType string

	// 产品列表价
	ListPrice int

	// 原价
	OriginalPrice int

	// 总价格
	Price int
}

/*
URedisBackupSet - DescribeURedisBackup
*/
type URedisBackupSet struct {

	// 备份ID
	BackupId string

	// 备份的名称
	BackupName string

	// 备份文件大小, 以字节为单位
	BackupSize int

	// 备份时间 (UNIX时间戳)
	BackupTime int

	// 备份类型: Manual 手动 Auto 自动
	BackupType string

	// 对应的实例ID
	GroupId string

	// 组名称
	GroupName string

	// 备份的状态: Backuping 备份中 Success 备份成功 Error 备份失败 Expired 备份过期
	State string

	// 可用区，参见[可用区列表](../summary/regionlist.html)
	Zone string
}

/*
URedisConfigSet - 主备Redis配置文件信息
*/
type URedisConfigSet struct {

	// 配置ID
	ConfigId string

	// 创建时间 (UNIX时间戳)
	CreateTime int

	// 配置描述
	Description string

	// 置是否可以修改
	IsModify string

	// 修改时间 (UNIX时间戳)
	ModifyTime int

	// 配置名称
	Name string

	// 是否是跨机房URedis(默认false)
	RegionFlag bool

	// 配置所处的状态
	State string

	// 配置对应的Redis版本
	Version string

	// Zone
	Zone string
}

/*
URedisGroupSet - DescribeURedisGroup
*/
type URedisGroupSet struct {

	// 是否需要自动备份,enable,disable
	AutoBackup string

	// 组自动备份开始时间,单位小时计,范围[0-23]
	BackupTime int

	// 计费类型:Year,Month,Dynamic 默认Dynamic
	ChargeType string

	// 节点的配置ID
	ConfigId string

	// 创建时间 (UNIX时间戳)
	CreateTime int

	// 过期时间 (UNIX时间戳)
	ExpireTime int

	// 组ID
	GroupId string

	// 组名称
	GroupName string

	// 是否开启高可用,enable,disable
	HighAvailability string

	// 容量单位GB
	MemorySize int

	// 修改时间 (UNIX时间戳)
	ModifyTime int

	// 组名称
	Name string

	// 节点分配的服务端口
	Port int

	// 协议
	Protocol string

	// 返回运维时间 0 //0点 1 //1点 以此类推
	RewriteTime int

	// 实例类型
	Role string

	// 容量单位GB
	Size int

	// 跨机房URedis，slave redis所在可用区，参见 [可用区列表](../summary/regionlist.html)
	SlaveZone string

	// 状态标记 Creating // 初始化中 CreateFail // 创建失败 Deleting // 删除中 DeleteFail // 删除失败 Running // 运行 Resizing // 容量调整中 ResizeFail // 容量调整失败 Configing // 配置中 ConfigFail // 配置失败
	State string

	// 子网
	SubnetId string

	// 业务组名称
	Tag string

	// 空间类型:single(无热备),double(热备)
	Type string

	// 使用量单位MB
	UsedSize int

	// VPCId
	VPCId string

	// Redis版本信息
	Version string

	// 节点的虚拟IP地址
	VirtualIP string

	// 实例所在可用区，或者master redis所在可用区，参见 [可用区列表](../summary/regionlist.html)
	Zone string
}

/*
URedisPriceSet - 主备Redis价格
*/
type URedisPriceSet struct {

	// Year， Month， Dynamic，Trial
	ChargeType string

	// 产品列表价
	ListPrice int

	// 原价
	OriginalPrice int

	// 总价格
	Price int
}

/*
URedisSlowlogSet - DescribeURedisSlowlog
*/
type URedisSlowlogSet struct {

	// 查询命令
	Command string

	// 查询消耗的时间
	SpendTime int

	// 查询发生的时间
	StartTime int
}

/*
URedisVersionSet - DescribeURedisVersion
*/
type URedisVersionSet struct {

	// Redis版本
	Version string
}
