// Code is generated by ucloud-model, DO NOT EDIT IT.

package tests

import (
	"testing"
	"time"

	"github.com/ucloud/ucloud-sdk-go/services/umem"
	"github.com/ucloud/ucloud-sdk-go/ucloud"
	"github.com/ucloud/ucloud-sdk-go/ucloud/utest/driver"
	"github.com/ucloud/ucloud-sdk-go/ucloud/utest/utils"
	"github.com/ucloud/ucloud-sdk-go/ucloud/utest/validation"
)

func TestScenario3338(t *testing.T) {
	spec.ParallelTest(t, &driver.Scenario{
		PreCheck: func() {
			testAccPreCheck(t)
		},
		Id: "3338",
		Vars: func(scenario *driver.Scenario) map[string]interface{} {
			return map[string]interface{}{
				"ResourceType": "single",
				"ConfigId":     "9a891891-c245-4b66-bce8-67e59430d67c",
				"Name":         "single_memcache",
				"Protocol":     "memcache",
				"Count":        1,
				"Size":         2,
				"SizeUp":       4,
				"Region":       "cn-bj2",
				"Zone":         "cn-bj2-02",
			}
		},
		Owners: []string{"yonge.li@ucloud.cn"},
		Title:  "SingleMemcache 2G",
		Steps: []*driver.Step{
			testStep3338CheckUMemcacheAllowance01,
			testStep3338CreateUMemcacheGroup02,
			testStep3338DescribeUMem03,
			testStep3338DescribeUMemcacheGroup04,
			testStep3338ResizeUMemcacheGroup05,
			testStep3338DescribeUMem06,
			testStep3338RestartUMemcacheGroup07,
			testStep3338DescribeUMem08,
			testStep3338DeleteUMemcacheGroup09,
			testStep3338DescribeUMem10,
		},
	})
}

var testStep3338CheckUMemcacheAllowance01 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("")
		if err != nil {
			return nil, err
		}
		client := c.(*ucloud.Client)

		req := client.NewGenericRequest()
		_ = req.SetAction("CheckUMemcacheAllowance")
		err = req.SetPayload(map[string]interface{}{
			"Zone":   step.Scenario.GetVar("Zone"),
			"Size":   step.Scenario.GetVar("Size"),
			"Region": step.Scenario.GetVar("Region"),
			"Count":  step.Scenario.GetVar("Count"),
		})
		if err != nil {
			return nil, err
		}
		resp, err := client.GenericInvoke(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("Action", "CheckUMemcacheAllowanceResponse", "str_eq"),
		}
	},
	StartupDelay:  time.Duration(0) * time.Second,
	MaxRetries:    3,
	RetryInterval: 1 * time.Second,
	Title:         "检查UMemcache剩余资源",
	FastFail:      false,
}

var testStep3338CreateUMemcacheGroup02 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("UMem")
		if err != nil {
			return nil, err
		}
		client := c.(*umem.UMemClient)

		req := client.NewCreateUMemcacheGroupRequest()
		err = utils.SetRequest(req, map[string]interface{}{
			"Zone":       step.Scenario.GetVar("Zone"),
			"Size":       step.Scenario.GetVar("Size"),
			"Region":     step.Scenario.GetVar("Region"),
			"Quantity":   1,
			"Name":       step.Scenario.GetVar("Name"),
			"ConfigId":   step.Scenario.GetVar("ConfigId"),
			"ChargeType": "Month",
		})
		if err != nil {
			return nil, err
		}

		resp, err := client.CreateUMemcacheGroup(req)
		if err != nil {
			return resp, err
		}

		step.Scenario.SetVar("group_id", step.Must(utils.GetValue(resp, "GroupId")))
		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("Action", "CreateUMemcacheGroupResponse", "str_eq"),
		}
	},
	StartupDelay:  time.Duration(0) * time.Second,
	MaxRetries:    3,
	RetryInterval: 1 * time.Second,
	Title:         "创建单机Memcache",
	FastFail:      false,
}

var testStep3338DescribeUMem03 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("")
		if err != nil {
			return nil, err
		}
		client := c.(*ucloud.Client)

		req := client.NewGenericRequest()
		_ = req.SetAction("DescribeUMem")
		err = req.SetPayload(map[string]interface{}{
			"ResourceId": step.Scenario.GetVar("group_id"),
			"Region":     step.Scenario.GetVar("Region"),
			"Protocol":   step.Scenario.GetVar("Protocol"),
			"Offset":     0,
			"Limit":      1000,
		})
		if err != nil {
			return nil, err
		}
		resp, err := client.GenericInvoke(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("DataSet.0.State", "Running", "str_eq"),
		}
	},
	StartupDelay:  time.Duration(60) * time.Second,
	MaxRetries:    30,
	RetryInterval: 30 * time.Second,
	Title:         "获取UMem列表",
	FastFail:      false,
}

var testStep3338DescribeUMemcacheGroup04 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("UMem")
		if err != nil {
			return nil, err
		}
		client := c.(*umem.UMemClient)

		req := client.NewDescribeUMemcacheGroupRequest()
		err = utils.SetRequest(req, map[string]interface{}{
			"Zone":    step.Scenario.GetVar("Zone"),
			"Region":  step.Scenario.GetVar("Region"),
			"Offset":  0,
			"Limit":   100,
			"GroupId": step.Scenario.GetVar("group_id"),
		})
		if err != nil {
			return nil, err
		}

		resp, err := client.DescribeUMemcacheGroup(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("Action", "DescribeUMemcacheGroupResponse", "str_eq"),
		}
	},
	StartupDelay:  time.Duration(100) * time.Second,
	MaxRetries:    3,
	RetryInterval: 1 * time.Second,
	Title:         "显示Memcache",
	FastFail:      true,
}

var testStep3338ResizeUMemcacheGroup05 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("")
		if err != nil {
			return nil, err
		}
		client := c.(*ucloud.Client)

		req := client.NewGenericRequest()
		_ = req.SetAction("ResizeUMemcacheGroup")
		err = req.SetPayload(map[string]interface{}{
			"Size":    step.Scenario.GetVar("SizeUp"),
			"Region":  step.Scenario.GetVar("Region"),
			"GroupId": step.Scenario.GetVar("group_id"),
		})
		if err != nil {
			return nil, err
		}
		resp, err := client.GenericInvoke(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
		}
	},
	StartupDelay:  time.Duration(0) * time.Second,
	MaxRetries:    0,
	RetryInterval: 0 * time.Second,
	Title:         "调整容量",
	FastFail:      false,
}

var testStep3338DescribeUMem06 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("")
		if err != nil {
			return nil, err
		}
		client := c.(*ucloud.Client)

		req := client.NewGenericRequest()
		_ = req.SetAction("DescribeUMem")
		err = req.SetPayload(map[string]interface{}{
			"ResourceId": step.Scenario.GetVar("group_id"),
			"Region":     step.Scenario.GetVar("Region"),
			"Protocol":   step.Scenario.GetVar("Protocol"),
			"Offset":     0,
			"Limit":      1000,
		})
		if err != nil {
			return nil, err
		}
		resp, err := client.GenericInvoke(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("DataSet.0.State", "Running", "str_eq"),
			validation.Builtins.NewValidator("DataSet.0.Size", step.Scenario.GetVar("SizeUp"), "str_eq"),
		}
	},
	StartupDelay:  time.Duration(60) * time.Second,
	MaxRetries:    30,
	RetryInterval: 60 * time.Second,
	Title:         "获取UMem列表",
	FastFail:      false,
}

var testStep3338RestartUMemcacheGroup07 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("UMem")
		if err != nil {
			return nil, err
		}
		client := c.(*umem.UMemClient)

		req := client.NewRestartUMemcacheGroupRequest()
		err = utils.SetRequest(req, map[string]interface{}{
			"Zone":    step.Scenario.GetVar("Zone"),
			"Region":  step.Scenario.GetVar("Region"),
			"GroupId": step.Scenario.GetVar("group_id"),
		})
		if err != nil {
			return nil, err
		}

		resp, err := client.RestartUMemcacheGroup(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
		}
	},
	StartupDelay:  time.Duration(0) * time.Second,
	MaxRetries:    0,
	RetryInterval: 0 * time.Second,
	Title:         "重启Memcache组",
	FastFail:      false,
}

var testStep3338DescribeUMem08 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("")
		if err != nil {
			return nil, err
		}
		client := c.(*ucloud.Client)

		req := client.NewGenericRequest()
		_ = req.SetAction("DescribeUMem")
		err = req.SetPayload(map[string]interface{}{
			"ResourceId": step.Scenario.GetVar("group_id"),
			"Region":     step.Scenario.GetVar("Region"),
			"Protocol":   step.Scenario.GetVar("Protocol"),
			"Offset":     0,
			"Limit":      1000,
		})
		if err != nil {
			return nil, err
		}
		resp, err := client.GenericInvoke(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("DataSet.0.State", "Running", "str_eq"),
		}
	},
	StartupDelay:  time.Duration(60) * time.Second,
	MaxRetries:    30,
	RetryInterval: 60 * time.Second,
	Title:         "获取UMem列表",
	FastFail:      false,
}

var testStep3338DeleteUMemcacheGroup09 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("UMem")
		if err != nil {
			return nil, err
		}
		client := c.(*umem.UMemClient)

		req := client.NewDeleteUMemcacheGroupRequest()
		err = utils.SetRequest(req, map[string]interface{}{
			"Zone":    step.Scenario.GetVar("Zone"),
			"Region":  step.Scenario.GetVar("Region"),
			"GroupId": step.Scenario.GetVar("group_id"),
		})
		if err != nil {
			return nil, err
		}

		resp, err := client.DeleteUMemcacheGroup(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("Action", "DeleteUMemcacheGroupResponse", "str_eq"),
		}
	},
	StartupDelay:  time.Duration(10) * time.Second,
	MaxRetries:    3,
	RetryInterval: 1 * time.Second,
	Title:         "删除单机Memcache",
	FastFail:      false,
}

var testStep3338DescribeUMem10 = &driver.Step{
	Invoker: func(step *driver.Step) (interface{}, error) {
		c, err := step.LoadFixture("")
		if err != nil {
			return nil, err
		}
		client := c.(*ucloud.Client)

		req := client.NewGenericRequest()
		_ = req.SetAction("DescribeUMem")
		err = req.SetPayload(map[string]interface{}{
			"ResourceId": step.Scenario.GetVar("group_id"),
			"Region":     step.Scenario.GetVar("Region"),
			"Protocol":   step.Scenario.GetVar("Protocol"),
			"Offset":     0,
			"Limit":      100,
		})
		if err != nil {
			return nil, err
		}
		resp, err := client.GenericInvoke(req)
		if err != nil {
			return resp, err
		}

		return resp, nil
	},
	Validators: func(step *driver.Step) []driver.TestValidator {
		return []driver.TestValidator{
			validation.Builtins.NewValidator("RetCode", 0, "str_eq"),
			validation.Builtins.NewValidator("Action", "DescribeUMemResponse", "str_eq"),
			validation.Builtins.NewValidator("DataSet", step.Scenario.GetVar("group_id"), "object_not_contains"),
		}
	},
	StartupDelay:  time.Duration(60) * time.Second,
	MaxRetries:    3,
	RetryInterval: 60 * time.Second,
	Title:         "获取UMem列表",
	FastFail:      false,
}
